xquery version "3.1";
(:~
 : Provides the endpoint for SADE Publish process
 :)

import module namespace index-creation="http://bdn-edition.de/ns/index-creation" at "../bdn/index-creation.xqm";
import module namespace internal-nav="http://bdn-edition.de/ns/internal-nav" at "../bdn/internal-nav.xqm";
import module namespace tgconnect="https://sade.textgrid.de/ns/connect" at "connect.xqm";

let $uri as xs:string := request:get-parameter("uri", ""),
    $sid as xs:string := request:get-parameter("sid", ""),
    $target as xs:string := request:get-parameter("target", "data"),
    $user as xs:string := request:get-parameter("user", ""),
    $password as xs:string := request:get-parameter("password", ""),
    $project as xs:string := request:get-parameter("project", ""),
    $surface as xs:string := request:get-parameter("sf", ""),
    $login as xs:boolean := false(),
    $operation as xs:string := request:get-parameter("operation", "")

return
    if( $operation = "" ) then
        error(QName("http://bdn-edition.de/ns/error", "OPERATION01"), "no opertaion provided")
    else if($operation = "overview") then
        <div>
          <ok>Overview saved to » {internal-nav:main()}</ok>
        </div>
    else if($operation = "indices") then
        <div>
          <ok>Created all index files. {index-creation:main()}</ok>
        </div>
    else
        error(QName("http://bdn-edition.de/ns/error", "OPERATION01"), "unknown operation: " || $operation)
